<template>
	<div class="map_container" ref="container" @mousemove="parallax($event)">
		<div
			class="full_map"
			:style="{
				left: `${-left}px`,
				top: `${-top}px`,
				position: 'relative',
				float: 'left',
				transform: `translateX(${-translation.x}px)translateY(${-translation.y}px)`
			}"
		>
			<template v-for="(place, index) in placeMap" :key="index">
				<img
					class="icon"
					:class="{
						myPos: myPos(place.placeId),
						canGo: canGo(place.placeId)
					}"
					:src="getImgURL('map/icon', place.icon)"
					:alt="place.icon"
					:style="{ left: place.posLeft + 'px', top: place.posTop + 'px' }"
					@click="moveTo(place.placeId)"
					@mouseenter="isHover(place.name, place.placeId, true)"
					@mouseleave="isHover(place.name, place.placeId, false)"
					v-tippy="{
						content: formatContent($t(`place.name.${place.name}`)),
						theme: 'small'
					}"
				/>
			</template>
			<svg
				version="1.1"
				width="100%"
				height="100%"
				:viewBox="svgSize"
				xmlns="http://www.w3.org/2000/svg"
				style="z-index: 100; position: absolute"
				id="svgDraw"
			>
				<template v-for="(line, index) in svgLines" :key="index">
					<line :x1="line.x1" :y1="line.y1" :x2="line.x2" :y2="line.y2" :id="line.name" class="svgLine" />
				</template>
			</svg>
			<img class="map-img" ref="carte" :src="getImgURL('map/map', getPlaceMap())" :alt="getPlaceMap()" />
		</div>
	</div>
</template>

<script lang="ts">
import { defineComponent, PropType } from 'vue';
import { placeList } from '../../constants/index.js';
import { PlaceDisplayed } from '@drpg/core/models/place/PlaceDisplayed';
import { svgLines } from '@drpg/core/models/place/svgLines';
import { dinozStore, sessionStore } from '../../store/index.js';
import EventBus from '../../events/index.js';
import { DinozService } from '../../services/index.js';
import { errorHandler } from '../../utils/index.js';
import { DinozFiche } from '@drpg/core/models/dinoz/DinozFiche';
import { UnavailableReasonFront } from '@drpg/core/models/dinoz/UnavailableReasonFront';
import { formatText } from '../../utils/formatText.js';

export default defineComponent({
	name: 'WorldMap',
	props: {
		dinozData: Object as PropType<DinozFiche>
	},
	data() {
		return {
			sessionStore: sessionStore(),
			dinozStore: dinozStore(),
			placeMap: [] as Array<PlaceDisplayed>,
			translation: {
				x: 0 as number,
				y: 0 as number
			},
			left: undefined as number | undefined,
			top: undefined as number | undefined,
			svgLines: [] as Array<svgLines>,
			svgSize: undefined as string | undefined
		};
	},
	methods: {
		parallax(e: MouseEvent) {
			const rect: DOMRect = document.querySelector('.map_container')!.getBoundingClientRect(); //taille du wrapper (250*300)
			const mapImage = document.querySelector('.full_map')!.getBoundingClientRect(); //taille de l'image de la map
			const xFactor = placeList.find(place => place.placeId === this.dinozData!.placeId)!.xFactor;
			const yFactor = placeList.find(place => place.placeId === this.dinozData!.placeId)!.yFactor;
			const centerMapY = mapImage.height - rect.height;
			const centerMapX = mapImage.width - rect.width;
			const centerX = rect.width / 2;
			const centerY = rect.height / 2;
			const mouseX = e.clientX - rect.left;
			const mouseY = e.clientY - rect.top;
			this.translation.x = Math.floor((-1 * (centerX - mouseX)) / xFactor);
			this.translation.y = Math.floor((-1 * (centerY - mouseY)) / yFactor);

			// Protect the translation top overflow
			if (this.top! + this.translation.y < 0) {
				this.translation.y = -this.top!;
			} else if (this.top! + this.translation.y > centerMapY) {
				this.translation.y = 0;
			}
			// Protect the translation left overflow
			if (this.left! + this.translation.x < 0) {
				this.translation.x = -this.left!;
			} else if (this.left! + this.translation.x > centerMapX) {
				this.translation.x = 0;
			}
		},
		getPlaceMap(): string {
			return placeList.find(place => place.placeId === this.dinozData!.placeId)!.map;
		},
		centerPos(mapImage: DOMRect) {
			const rect: DOMRect = document.querySelector('.map_container')!.getBoundingClientRect(); // taille du wrapper (250*300)
			let centerMapY: number = mapImage.height - rect.height;
			let centerMapX: number = mapImage.width - rect.width;
			const boxMap = document.getElementById('boxMap') as HTMLDivElement;
			if (boxMap && centerMapX < 0) {
				boxMap.style.width = mapImage.width + 'px';
				centerMapX = 0;
			}
			if (boxMap && centerMapY < 0) {
				boxMap.style.height = mapImage.height + 'px';
				centerMapY = 0;
			}

			const centerX: number = rect.width / 2;
			const centerY: number = rect.height / 2;
			const actualPlace = placeList.find(place => place.placeId === this.dinozData!.placeId)!;

			this.left = actualPlace.posLeft - centerX;
			this.top = actualPlace.posTop - centerY;
			// Protect the initial top overflow
			if (this.top + this.translation.y < 0) {
				this.top = 0;
			} else if (this.top + this.translation.y > centerMapY) {
				this.top = centerMapY;
			}
			// Protect the initial left overflow
			if (this.left + this.translation.x < 0) {
				this.left = 0;
			} else if (this.left + this.translation.x > centerMapX) {
				this.left = centerMapX;
			}
		},
		async moveTo(placeId: number): Promise<void> {
			if (!this.dinozData!.borderPlace?.includes(placeId)) {
				return;
			}
			EventBus.emit('isLoading', true);

			// Check if dinoz is being sold
			if (this.dinozData?.unavailableReason === UnavailableReasonFront.selling) {
				this.$toast.open({ message: formatText(this.$t(`toast.isSelling`)), type: 'error' });
				return;
			}

			try {
				const moveTry = await DinozService.betaMove(this.dinozData!.id!, placeId);
				this.sessionStore.setFightResult(moveTry);
				// Update Dinoz Place in the store if fight is win
				const dinozId = this.dinozData?.id;
				const dinozList = this.dinozStore.getDinozList;
				const place = placeList.find(place => place.placeId === placeId);

				if (!dinozList || !dinozId || !place) {
					this.$toast.open({
						message: formatText(this.$t(`toast.missingData`)),
						type: 'error'
					});
					EventBus.emit('isLoading', false);
					return;
				}

				if (moveTry.result) {
					this.dinozStore.setDinozList(
						dinozList.map(dinoz => {
							if (dinoz.id === dinozId || dinoz.leaderId === dinozId) {
								if (dinoz.life !== 0) {
									// Update dinoz place
									dinoz.placeId = place.alias || placeId;

									// Update dinoz HP
									dinoz.life -= moveTry.hpLost.find(hpLost => hpLost.id === dinoz.id)?.hpLost || 0;
								} else {
									//Remove dead dinoz from the party
									dinoz.leaderId = null;
								}
							}
							return dinoz;
						})
					);
				}
				this.dinozStore.clearNpc(dinozId);
				this.$router.push({
					name: 'Fight',
					params: { dinozId: this.dinozData?.id?.toString() }
				});
			} catch (err) {
				errorHandler.handle(err, this.$toast);
				return;
			}
		},
		myPos(placeId: number): boolean {
			return placeId === this.dinozData!.placeId;
		},
		canGo(placeId: number): boolean {
			return this.dinozData!.borderPlace!.includes(placeId);
		},
		svgMagic(mapImage: DOMRect): void {
			let mapX = 0;
			let mapY = 0;
			if (mapImage.height > mapImage.width) {
				this.svgSize = `0 0 ${(mapImage.width / mapImage.height) * 100} 100`;
				mapY = 100;
				mapX = (mapImage.width / mapImage.height) * 100;
			} else {
				this.svgSize = `0 0 100 ${(mapImage.height / mapImage.width) * 100}`;
				mapY = (mapImage.height / mapImage.width) * 100;
				mapX = 100;
			}
			const actualPlace: PlaceDisplayed | undefined = placeList.find(
				place => place.placeId === this.dinozData!.placeId
			);
			const x1 = ((actualPlace!.posLeft + 8.5) / mapImage.width) * mapX;
			const y1 = ((actualPlace!.posTop + 8.5) / mapImage.height) * mapY;

			this.dinozData!.borderPlace!.forEach(closePlace => {
				const place: PlaceDisplayed = placeList.find(place => place.placeId === closePlace)!;
				const x2: number = ((place.posLeft! + 8.5) / mapImage.width) * mapX;
				const y2: number = ((place.posTop! + 8.5) / mapImage.height) * mapY;
				this.svgLines.push({ x1, y1, x2, y2, name: place.name });
			});
		},
		isHover(placeName: string, placeId: number, state: boolean): void {
			const line: Element | null = document.querySelector(`#${placeName}`);
			if (this.canGo(placeId)) {
				state ? line!.classList.add('isHover') : line!.classList.remove('isHover');
			}
		},
		waitForImageToLoad(): void {
			setTimeout(() => {
				const mapImage: DOMRect = (this.$refs.carte as Element).getBoundingClientRect();
				if (mapImage.width < 300) {
					this.waitForImageToLoad();
				} else {
					this.centerPos(mapImage);
					this.svgMagic(mapImage);
				}
			}, 100);
		}
	},
	mounted(): void {
		const map = placeList.find(place => place.placeId === this.dinozData!.placeId)!.map;
		// We only keep places that belong to the current map and places that dinoz can reach (useful for hidden ones)
		this.placeMap = placeList.filter(
			place =>
				place.map === map &&
				(!place.hidden ||
					this.dinozData!.borderPlace!.includes(place.placeId) ||
					place.placeId === this.dinozData?.placeId)
		);

		this.waitForImageToLoad();
	}
});
</script>

<style lang="scss" scoped>
.map_container {
	height: 250px;
	overflow: hidden;
	position: relative;
}
.full_map {
	position: relative;
	width: fit-content;
	height: auto;
	transition:
		top 1s,
		left 1s;
	pointer-events: none;
}
.myPos {
	filter: drop-shadow(1px 1px 2px white) drop-shadow(-1px -1px 2px white);
}
.canGo {
	cursor: pointer;
	z-index: 500 !important;
}
.imgHidden {
	display: none;
}
.icon {
	position: absolute;
	pointer-events: auto;
	z-index: 200;
	&:hover {
		animation: blinker 1s linear infinite;
		filter: drop-shadow(0 0 2px white);
	}
}
.isHover {
	stroke-dasharray: 1;
	animation: svgAnime 20s linear infinite;
}
.svgLine {
	stroke: gray;
	stroke-width: 1px;
}
@keyframes blinker {
	50% {
		filter: brightness(150%) drop-shadow(0 0 2px white);
	}
}

@keyframes svgAnime {
	0% {
		stroke-dashoffset: 100;
	}
	100% {
		stroke-dashoffset: 0;
	}
}
</style>
